# -*- coding: utf-8 -*-
# Code by Madhouse
import gettext
from os import path, chmod, environ, popen, mkdir
from Components.Language import language
from Tools.Directories import resolveFilename, SCOPE_LANGUAGE
from enigma import getDesktop
from skin import loadSkin
from Components.config import config

plugin_path = "/usr/lib/enigma2/python/Plugins/Extensions/Wireguard/moduli/speedtest.py"
cmd = "python " + plugin_path + " --no-pre-allocate --share --secure"
png_tmp = "/tmp/speedtest.png"
headers = {"User-Agent": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.64 Safari/537.11",
	   "Accept": "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8",
	   "Accept-Charset": "ISO-8859-1,utf-8;q=0.7,*;q=0.3",
	   "Accept-Encoding": "none",
	   "Accept-Language": "en-US,en;q=0.8",
	   "Connection": "keep-alive"}

if path.exists(plugin_path):
	chmod(plugin_path, 0o755)

PluginLanguageDomain = "Wireguard"
PluginLanguagePath = "/usr/lib/enigma2/python/Plugins/Extensions/Wireguard/locale"

ProviderList = "Surfshark, NordVpn, ProtonVpn, MullvadVpn, IVpn"

PrivateKey = "/etc/PrivateKey.key"
PrivateKeyHdd = "/media/hdd/WgConfig/PrivateKey.key"
PrivateKeyUsb = "/media/usb/WgConfig/PrivateKey.key"

FileBypass = "WireguardBypass.txt"

WgShow = "wg show"

Version = "5.5"

if path.exists("/etc/hostname"):
	Model = open("/etc/hostname", "r")
	Models = Model.read().replace("\n", "")
	StbModel = Models.capitalize()
	Model.close()
else:
	StbModel = "Box"

SKIN_PATH = "/usr/lib/enigma2/python/Plugins/Extensions/Wireguard/skin"

PathBypassHdd = "/media/hdd/WgConfig/WireguardBypass.txt"
PathBypassUsb = "/media/usb/WgConfig/WireguardBypass.txt"
PathBypass = "/etc/WgConfig/WireguardBypass.txt"

logo_wireguard = "/usr/lib/enigma2/python/Plugins/Extensions/Wireguard/skin/fhd/icons/logo_wireguard.png"

HD = getDesktop(0).size()
if HD.width() > 1280:
	loadSkin(SKIN_PATH + "/fhd/speedtest.xml")
else:
	loadSkin(SKIN_PATH + "/hd/speedtest.xml")

# Directory file .conf
Directory = "/usr/lib/enigma2/python/Plugins/Extensions/Wireguard/ConfigFile"

if not path.exists("/etc/wireguard"):
	mkdir("/etc/wireguard", 0o755)

try:
	if not path.exists("/media/hdd"):
		mkdir("/media/hdd", 0o755)
	if not path.exists("/media/hdd/WgConfig"):
		mkdir("/media/hdd/WgConfig", 0o755)
	if not path.exists(PathBypassHdd):
		open(PathBypassHdd, "w").close()
	if not path.exists("/media/hdd/WgConfig/PrivateKey.key"):
		open("/media/hdd/WgConfig/PrivateKey.key", "w").close()
except OSError as e:
	print("Can't create destination directory (%s)!" % e)
	pass

try:
	if not path.exists("/media/usb/WgConfig"):
		mkdir("/media/usb/WgConfig", 0o755)
	if not path.exists(PathBypassUsb):
		open(PathBypassUsb, "w").close()
	if not path.exists("/media/usb/WgConfig/PrivateKey.key"):
		open("/media/usb/WgConfig/PrivateKey.key", "w").close()
except OSError as e:
	print("Can't create destination directory (%s)!" % e)
	pass

if not path.exists("/etc/WgConfig"):
	mkdir("/etc/WgConfig", 0o755)
if not path.exists(PathBypass):
	open(PathBypass, "w").close()

if not path.exists(PrivateKey):
	open(PrivateKey, "w").close()

if path.exists("/etc/init.d/wireguard"):
	chmod("/etc/init.d/wireguard", 0o755)

if path.exists("/etc/init.d/ipv6_disable"):
	chmod("/etc/init.d/ipv6_disable", 0o755)

def localeInit():
	lang = language.getLanguage()[:2]
	environ["LANGUAGE"] = lang
	gettext.bindtextdomain(PluginLanguageDomain, PluginLanguagePath)
	gettext.bindtextdomain("enigma2", resolveFilename(SCOPE_LANGUAGE, ""))

def _(txt):
	t = gettext.dgettext(PluginLanguageDomain, txt)
	if t == txt:
		t = gettext.dgettext("enigma2", txt)
	return t

localeInit()
language.addCallback(localeInit)
